// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Map.proto

#ifndef PROTOBUF_INCLUDED_Map_2eproto
#define PROTOBUF_INCLUDED_Map_2eproto

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3006001
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3006001 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/inlined_string_field.h>
#include <google/protobuf/metadata_lite.h>
#include <google/protobuf/message_lite.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include "Material.pb.h"
// @@protoc_insertion_point(includes)
#define PROTOBUF_INTERNAL_EXPORT_protobuf_Map_2eproto 

namespace protobuf_Map_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[1];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
}  // namespace protobuf_Map_2eproto
namespace dfproto {
class Map;
class MapDefaultTypeInternal;
extern MapDefaultTypeInternal _Map_default_instance_;
}  // namespace dfproto
namespace google {
namespace protobuf {
template<> ::dfproto::Map* Arena::CreateMaybeMessage<::dfproto::Map>(Arena*);
}  // namespace protobuf
}  // namespace google
namespace dfproto {

// ===================================================================

class Map : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:dfproto.Map) */ {
 public:
  Map();
  virtual ~Map();

  Map(const Map& from);

  inline Map& operator=(const Map& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  Map(Map&& from) noexcept
    : Map() {
    *this = ::std::move(from);
  }

  inline Map& operator=(Map&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const Map& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Map* internal_default_instance() {
    return reinterpret_cast<const Map*>(
               &_Map_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    0;

  void Swap(Map* other);
  friend void swap(Map& a, Map& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Map* New() const final {
    return CreateMaybeMessage<Map>(NULL);
  }

  Map* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<Map>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const Map& from);
  void MergeFrom(const Map& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(Map* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .dfproto.Material inorganic_material = 4;
  int inorganic_material_size() const;
  void clear_inorganic_material();
  static const int kInorganicMaterialFieldNumber = 4;
  ::dfproto::Material* mutable_inorganic_material(int index);
  ::google::protobuf::RepeatedPtrField< ::dfproto::Material >*
      mutable_inorganic_material();
  const ::dfproto::Material& inorganic_material(int index) const;
  ::dfproto::Material* add_inorganic_material();
  const ::google::protobuf::RepeatedPtrField< ::dfproto::Material >&
      inorganic_material() const;

  // repeated .dfproto.Material organic_material = 5;
  int organic_material_size() const;
  void clear_organic_material();
  static const int kOrganicMaterialFieldNumber = 5;
  ::dfproto::Material* mutable_organic_material(int index);
  ::google::protobuf::RepeatedPtrField< ::dfproto::Material >*
      mutable_organic_material();
  const ::dfproto::Material& organic_material(int index) const;
  ::dfproto::Material* add_organic_material();
  const ::google::protobuf::RepeatedPtrField< ::dfproto::Material >&
      organic_material() const;

  // required uint32 x_size = 1;
  bool has_x_size() const;
  void clear_x_size();
  static const int kXSizeFieldNumber = 1;
  ::google::protobuf::uint32 x_size() const;
  void set_x_size(::google::protobuf::uint32 value);

  // required uint32 y_size = 2;
  bool has_y_size() const;
  void clear_y_size();
  static const int kYSizeFieldNumber = 2;
  ::google::protobuf::uint32 y_size() const;
  void set_y_size(::google::protobuf::uint32 value);

  // required uint32 z_size = 3;
  bool has_z_size() const;
  void clear_z_size();
  static const int kZSizeFieldNumber = 3;
  ::google::protobuf::uint32 z_size() const;
  void set_z_size(::google::protobuf::uint32 value);

  // @@protoc_insertion_point(class_scope:dfproto.Map)
 private:
  void set_has_x_size();
  void clear_has_x_size();
  void set_has_y_size();
  void clear_has_y_size();
  void set_has_z_size();
  void clear_has_z_size();

  // helper for ByteSizeLong()
  size_t RequiredFieldsByteSizeFallback() const;

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::google::protobuf::RepeatedPtrField< ::dfproto::Material > inorganic_material_;
  ::google::protobuf::RepeatedPtrField< ::dfproto::Material > organic_material_;
  ::google::protobuf::uint32 x_size_;
  ::google::protobuf::uint32 y_size_;
  ::google::protobuf::uint32 z_size_;
  friend struct ::protobuf_Map_2eproto::TableStruct;
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// Map

// required uint32 x_size = 1;
inline bool Map::has_x_size() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void Map::set_has_x_size() {
  _has_bits_[0] |= 0x00000001u;
}
inline void Map::clear_has_x_size() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void Map::clear_x_size() {
  x_size_ = 0u;
  clear_has_x_size();
}
inline ::google::protobuf::uint32 Map::x_size() const {
  // @@protoc_insertion_point(field_get:dfproto.Map.x_size)
  return x_size_;
}
inline void Map::set_x_size(::google::protobuf::uint32 value) {
  set_has_x_size();
  x_size_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Map.x_size)
}

// required uint32 y_size = 2;
inline bool Map::has_y_size() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void Map::set_has_y_size() {
  _has_bits_[0] |= 0x00000002u;
}
inline void Map::clear_has_y_size() {
  _has_bits_[0] &= ~0x00000002u;
}
inline void Map::clear_y_size() {
  y_size_ = 0u;
  clear_has_y_size();
}
inline ::google::protobuf::uint32 Map::y_size() const {
  // @@protoc_insertion_point(field_get:dfproto.Map.y_size)
  return y_size_;
}
inline void Map::set_y_size(::google::protobuf::uint32 value) {
  set_has_y_size();
  y_size_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Map.y_size)
}

// required uint32 z_size = 3;
inline bool Map::has_z_size() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
inline void Map::set_has_z_size() {
  _has_bits_[0] |= 0x00000004u;
}
inline void Map::clear_has_z_size() {
  _has_bits_[0] &= ~0x00000004u;
}
inline void Map::clear_z_size() {
  z_size_ = 0u;
  clear_has_z_size();
}
inline ::google::protobuf::uint32 Map::z_size() const {
  // @@protoc_insertion_point(field_get:dfproto.Map.z_size)
  return z_size_;
}
inline void Map::set_z_size(::google::protobuf::uint32 value) {
  set_has_z_size();
  z_size_ = value;
  // @@protoc_insertion_point(field_set:dfproto.Map.z_size)
}

// repeated .dfproto.Material inorganic_material = 4;
inline int Map::inorganic_material_size() const {
  return inorganic_material_.size();
}
inline ::dfproto::Material* Map::mutable_inorganic_material(int index) {
  // @@protoc_insertion_point(field_mutable:dfproto.Map.inorganic_material)
  return inorganic_material_.Mutable(index);
}
inline ::google::protobuf::RepeatedPtrField< ::dfproto::Material >*
Map::mutable_inorganic_material() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.Map.inorganic_material)
  return &inorganic_material_;
}
inline const ::dfproto::Material& Map::inorganic_material(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.Map.inorganic_material)
  return inorganic_material_.Get(index);
}
inline ::dfproto::Material* Map::add_inorganic_material() {
  // @@protoc_insertion_point(field_add:dfproto.Map.inorganic_material)
  return inorganic_material_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::dfproto::Material >&
Map::inorganic_material() const {
  // @@protoc_insertion_point(field_list:dfproto.Map.inorganic_material)
  return inorganic_material_;
}

// repeated .dfproto.Material organic_material = 5;
inline int Map::organic_material_size() const {
  return organic_material_.size();
}
inline ::dfproto::Material* Map::mutable_organic_material(int index) {
  // @@protoc_insertion_point(field_mutable:dfproto.Map.organic_material)
  return organic_material_.Mutable(index);
}
inline ::google::protobuf::RepeatedPtrField< ::dfproto::Material >*
Map::mutable_organic_material() {
  // @@protoc_insertion_point(field_mutable_list:dfproto.Map.organic_material)
  return &organic_material_;
}
inline const ::dfproto::Material& Map::organic_material(int index) const {
  // @@protoc_insertion_point(field_get:dfproto.Map.organic_material)
  return organic_material_.Get(index);
}
inline ::dfproto::Material* Map::add_organic_material() {
  // @@protoc_insertion_point(field_add:dfproto.Map.organic_material)
  return organic_material_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::dfproto::Material >&
Map::organic_material() const {
  // @@protoc_insertion_point(field_list:dfproto.Map.organic_material)
  return organic_material_;
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__

// @@protoc_insertion_point(namespace_scope)

}  // namespace dfproto

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_INCLUDED_Map_2eproto
